#!/usr/bin/python
# rhn_scraper, a class to scrape rhn page
# Copyright 2009 Pierre Amadio 
# pamadio@redhat.com
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation version 2.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
"""
python-mechanize used to be available in EPEL.
It's not the case anymore for RHEL6.

upstream project is http://wwwsearch.sourceforge.net/mechanize/download.html
Create a package with python setup.py bdist_rpm
"""
import mechanize
import urllib2
import sys
sys.path.append("/usr/share/checksysreport")
import globals
from HTMLParser import HTMLParser
import re

class packages_details_overview_parser(HTMLParser):
    
    def __init__(self):
        HTMLParser.__init__(self)
        self.binary_url=False
        self.srcrpm_url=False
        self.debug_url=False
    
    def handle_starttag(self, tag, attrs):
        if tag!="a":
            return 
        
        if attrs[0][0]!="href":
            return 
        target_url=attrs[0][1]

        if re.compile("https://content-web.rhn.redhat.com/.*SRPMS").search(target_url):
            self.srcrpm_url=target_url
            return

        if re.compile("https://content-web.rhn.redhat.com/rhn/public/NULL/\w+-debuginfo/").search(target_url):
            self.debug_url=target_url
            return 

        if re.compile("https://content-web.rhn.redhat.com/").search(target_url):
            self.binary_url=target_url
            return


        if re.compile("ftp://ftp.redhat.com/pub/redhat/linux/enterprise").search(target_url):
            self.debug_url=target_url

            """
            For RHEL4, the debug info on the rhn page is
            ftp://ftp.redhat.com/pub/redhat/linux/enterprise/4Desktop/en/os/i386/Debuginfo/python-debuginfo-2.3.4-14.7.el4_8.2.i386.rpm
            it should be
            ftp://ftp.redhat.com/pub/redhat/linux/updates/enterprise/4AS/en/os/Debuginfo/i386/RPMS/python-debuginfo-2.3.4-14.7.el4_8.2.i386.rpm
not         ftp://ftp.redhat.com/pub/redhat/linux/updates/enterprise/4Desktop/en/os/i386/Debuginfo/python-debuginfo-2.3.4-14.7.el4_8.2.i386.rpm


            
            RHEL5 is ok:
            ftp://ftp.redhat.com/pub/redhat/linux/enterprise/5Server/en/os/i386/Debuginfo/

            Lets change the url whenever it looks like http://.*enterprise/4.* 
        
            """
            testWorkaroundRHEL4="ftp://\S+/enterprise/(4\S*)/en/os/(\S*)/Debuginfo/(\S+rpm)"
            if re.compile(testWorkaroundRHEL4).search(target_url):
                flavor=re.compile(testWorkaroundRHEL4).search(target_url).group(1)
                arch=re.compile(testWorkaroundRHEL4).search(target_url).group(2)
                rest=re.compile(testWorkaroundRHEL4).search(target_url).group(3)
                self.debug_url="ftp://ftp.redhat.com/pub/redhat/linux/updates/enterprise/%s/en/os/Debuginfo/%s/RPMS/%s"%(flavor,arch,rest)
            
            return

    def handle_endtag(self, tag):
        #print "Encountered the end of a %s tag" % tag
        return

class rhn_scraper:
    
    def __init__(self,rhn_login,rhn_password,rhn_url="https://rhn.redhat.com/"):
        self.rhn_login=rhn_login
        self.rhn_password=rhn_password
        self.rhn_url=rhn_url


    def get_url(self,url):
        out=False
        #print "get_url('%s')"%url
        request = mechanize.Request(url)
        try:
            response = mechanize.urlopen(request)
        except urllib2.URLError, error:
            print "ERROR ",error
            #print request
            raise

        
        infos=response.info()
        cookiesnt=infos.getheader("Set-Cookie")
        #print "cookiesnt=",cookiesnt

        
        if cookiesnt.count("JSESSIONID"):
            #print "JSESSIONID Cookie set: needs to log in"
            forms=mechanize.ParseResponse(response, backwards_compat=False)
            forms[0]["username"]=self.rhn_login
            forms[0]["password"]=self.rhn_password
            request2 = forms[0].click()
            response2 = mechanize.urlopen(request2)
            response.close()
            out=response2.read()
        else:
            out=response.read()

        return out


    def get_download_urls_for_package(self,package_id):
        raw_html=self.get_url("%srhn/software/packages/details/Overview.do?pid=%d"%(self.rhn_url,package_id))
        parser=packages_details_overview_parser()
        parser.feed(raw_html)
        parser.close()
        return {'binary':parser.binary_url,'src':parser.srcrpm_url,'debug':parser.debug_url}

